@Library('ciLib')

import java.text.DecimalFormat
import java.text.DecimalFormatSymbols
import groovy.json.JsonSlurperClassic

def shLib = new ciserver.shdLib()
def microservice = "mircro-code"
def namespace = "test"
def config = "mircro-code-ciconfig"
def BRANCH_NAME = "master"

def RELEASE_VERSION = ''



pipeline {
  agent {
    kubernetes {
      label 'jenkins-backend-agent'
      yaml libraryResource('k8s_specs/backendPodSpecs.yaml')
    }
  }
  stages {
    stage('Build Maven Project') {
      steps {
        container('podman-ubuntu') {
            script {
                try {
                    shLib.setWorkspace(env.BRANCH_NAME)
                    shLib.mavenVersion()
                    shLib.buildMvn()

                } catch (e) {
                    currentBuild.result = "FAILED"
                    throw e
                }
            }
        }
      }
    }
    stage('Prepare configuration files') {
        steps {
            container('podman-ubuntu') {
                script {
                    try {
                        shLib.connecGitlab()
                        shLib.prepareConfigFiles(env.BRANCH_NAME, namespace, config, microservice)

                    } catch (e) {
                        currentBuild.result = "FAILED"
                        throw e

                    }
                }
            }
        }
    }
    stage('Build & Push container to ECR') {
        steps {
            container('podman-ubuntu') {

                script {
                    try {
                        shLib.buildPushContainer(env.BRANCH_NAME, namespace, config, microservice)

                    } catch (e) {
                        currentBuild.result = "FAILED"
                        throw e
                    }
                }
            }
        }
    }
    stage('Publish Helm Chart') {
        steps {
            container('podman-ubuntu') {
                script {
                    try {
                        shLib.deployToCluster(env.BRANCH_NAME, config, microservice, namespace)

                    } catch (e) {
                        currentBuild.result = "FAILED"
                        throw e
                    }

                }
            }
        }
    }
  }
}
